<template>
  <v-dialog
    v-model="logoutDialog"
    persistent
    max-width="30%"
  >
    <v-card id="logout-dialog">
      <v-card-title class="headline">
        You'll be logged out!
      </v-card-title>
      <v-card-text>
        Due to inactivity you'll be logged out in a couple of moments.<br>
        Any unsaved work will be lost.
        Click Continue to stay logged in.
      </v-card-text>
      <v-card-actions>
        <v-btn
          id="logout-btn"
          text
          color="grey lighten-0"
          @click="logout"
        >
          Logout now
        </v-btn>
        <v-spacer />
        <v-btn
          id="continue-btn"
          text
          color="blue darken-2"
          @click="continueWork"
        >
          Continue
        </v-btn>
      </v-card-actions>
    </v-card>
  </v-dialog>
</template>

<script lang="ts">
import Vue from 'vue'
import Component, { mixins } from 'vue-class-component'
import { Watch } from 'vue-property-decorator'
import { mapState } from 'vuex'
import { Authentication } from '@/store/modules/authentication'
import { actions } from '@/store/actions'
import { getters } from '@/store/getters'
import { ConfigModule } from '../store/modules/config'
import * as api from '@/api'

@Component({
  name: 'auto-logout'
})
export default class AutoLogout extends Vue {
  timer = 0
  logoutDialog = false

  get lastTokenRefreshTry () { return Authentication.state.lastTokenRefreshTry }
  get refreshingToken () { return Authentication.state.refreshingToken }
  get jwtTimeDelta () { return ConfigModule.state.config.timeDelta }
  get lastAppInteraction () { return  getters.state.lastAppInteraction }
  get accessToken () { return Authentication.state.token }

  logout () {
      this.logoutDialog = false
      actions.logout('You have been logged out due to inactivity.')
  }

  continueWork () {
      Authentication.refreshJWT()
      this.logoutDialog = false
  }

  @Watch('lastAppInteraction')
  onLastInteractionChange () {
    const timeSinceLastRefresh = Date.now() - this.lastTokenRefreshTry
      const timeDelta = this.jwtTimeDelta
      // refresh jwt if it's older than 20% of his maximum age
      if (this.$route.name !== 'login' && timeSinceLastRefresh > timeDelta * 0.2 &&
          !this.refreshingToken) {
        Authentication.refreshJWT()
      }
  }

  mounted () {
    // release locked assignments when user is logged in and page is closed
    window.addEventListener('unload', (event: Event) => {
      // we use synchronous xhr's here to prevent the page from unloading before the request was finished
      if (this.accessToken !== '' && Authentication.isTutorOrReviewer) {
        api.releaseUndoneAssignmentsSynchronized(this.accessToken)
      }
      if (this.accessToken !== '' && Authentication.isStudent && !ConfigModule.state.config.instanceSettings.exerciseMode) {
        api.disableAccount(this.accessToken, Authentication.state.user.pk)
      }
    }, false)

    this.timer = setInterval(() => {
      const timeDialogAppearsBeforeLogout = Math.min(600 * 1e3,
        this.jwtTimeDelta ? this.jwtTimeDelta * 0.5 : Infinity)
      if (this.$route.name !== 'login' && Authentication.isLoggedIn) {
        if (Date.now() > this.lastTokenRefreshTry + this.jwtTimeDelta) {
          this.logoutDialog = false
          actions.logout('You\'ve been logged out due to inactivity.')
        } else if (Date.now() + timeDialogAppearsBeforeLogout > this.lastTokenRefreshTry + this.jwtTimeDelta) {
          this.logoutDialog = true
        }
      }
    }, 1 * 1e3)
  }

  beforeDestroy () {
    clearInterval(this.timer)
  }
}
</script>

<style>
</style>
